library ieee;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
library work;
use work.std_logic_arithext.all;


--datapath entity
entity permutation is
   port(
      A:in std_logic_vector(1023 downto 0);
      B:out std_logic_vector(1023 downto 0);
      rst_n : in std_logic;
      clk : in std_logic

   );
end permutation;


--signal declaration
architecture RTL of permutation is
signal s_A:std_logic_vector(1023 downto 0);
signal sig_0:std_logic_vector(7 downto 0);
signal sig_1:std_logic_vector(11 downto 0);
signal sig_2:std_logic_vector(15 downto 0);
signal sig_3:std_logic_vector(19 downto 0);
signal sig_4:std_logic_vector(23 downto 0);
signal sig_5:std_logic_vector(27 downto 0);
signal sig_6:std_logic_vector(31 downto 0);
signal sig_7:std_logic_vector(35 downto 0);
signal sig_8:std_logic_vector(39 downto 0);
signal sig_9:std_logic_vector(43 downto 0);
signal sig_10:std_logic_vector(47 downto 0);
signal sig_11:std_logic_vector(51 downto 0);
signal sig_12:std_logic_vector(55 downto 0);
signal sig_13:std_logic_vector(59 downto 0);
signal sig_14:std_logic_vector(63 downto 0);
signal sig_15:std_logic_vector(67 downto 0);
signal sig_16:std_logic_vector(71 downto 0);
signal sig_17:std_logic_vector(75 downto 0);
signal sig_18:std_logic_vector(79 downto 0);
signal sig_19:std_logic_vector(83 downto 0);
signal sig_20:std_logic_vector(87 downto 0);
signal sig_21:std_logic_vector(91 downto 0);
signal sig_22:std_logic_vector(95 downto 0);
signal sig_23:std_logic_vector(99 downto 0);
signal sig_24:std_logic_vector(103 downto 0);
signal sig_25:std_logic_vector(107 downto 0);
signal sig_26:std_logic_vector(111 downto 0);
signal sig_27:std_logic_vector(115 downto 0);
signal sig_28:std_logic_vector(119 downto 0);
signal sig_29:std_logic_vector(123 downto 0);
signal sig_30:std_logic_vector(127 downto 0);
signal sig_31:std_logic_vector(131 downto 0);
signal sig_32:std_logic_vector(135 downto 0);
signal sig_33:std_logic_vector(139 downto 0);
signal sig_34:std_logic_vector(143 downto 0);
signal sig_35:std_logic_vector(147 downto 0);
signal sig_36:std_logic_vector(151 downto 0);
signal sig_37:std_logic_vector(155 downto 0);
signal sig_38:std_logic_vector(159 downto 0);
signal sig_39:std_logic_vector(163 downto 0);
signal sig_40:std_logic_vector(167 downto 0);
signal sig_41:std_logic_vector(171 downto 0);
signal sig_42:std_logic_vector(175 downto 0);
signal sig_43:std_logic_vector(179 downto 0);
signal sig_44:std_logic_vector(183 downto 0);
signal sig_45:std_logic_vector(187 downto 0);
signal sig_46:std_logic_vector(191 downto 0);
signal sig_47:std_logic_vector(195 downto 0);
signal sig_48:std_logic_vector(199 downto 0);
signal sig_49:std_logic_vector(203 downto 0);
signal sig_50:std_logic_vector(207 downto 0);
signal sig_51:std_logic_vector(211 downto 0);
signal sig_52:std_logic_vector(215 downto 0);
signal sig_53:std_logic_vector(219 downto 0);
signal sig_54:std_logic_vector(223 downto 0);
signal sig_55:std_logic_vector(227 downto 0);
signal sig_56:std_logic_vector(231 downto 0);
signal sig_57:std_logic_vector(235 downto 0);
signal sig_58:std_logic_vector(239 downto 0);
signal sig_59:std_logic_vector(243 downto 0);
signal sig_60:std_logic_vector(247 downto 0);
signal sig_61:std_logic_vector(251 downto 0);
signal sig_62:std_logic_vector(255 downto 0);
signal sig_63:std_logic_vector(259 downto 0);
signal sig_64:std_logic_vector(263 downto 0);
signal sig_65:std_logic_vector(267 downto 0);
signal sig_66:std_logic_vector(271 downto 0);
signal sig_67:std_logic_vector(275 downto 0);
signal sig_68:std_logic_vector(279 downto 0);
signal sig_69:std_logic_vector(283 downto 0);
signal sig_70:std_logic_vector(287 downto 0);
signal sig_71:std_logic_vector(291 downto 0);
signal sig_72:std_logic_vector(295 downto 0);
signal sig_73:std_logic_vector(299 downto 0);
signal sig_74:std_logic_vector(303 downto 0);
signal sig_75:std_logic_vector(307 downto 0);
signal sig_76:std_logic_vector(311 downto 0);
signal sig_77:std_logic_vector(315 downto 0);
signal sig_78:std_logic_vector(319 downto 0);
signal sig_79:std_logic_vector(323 downto 0);
signal sig_80:std_logic_vector(327 downto 0);
signal sig_81:std_logic_vector(331 downto 0);
signal sig_82:std_logic_vector(335 downto 0);
signal sig_83:std_logic_vector(339 downto 0);
signal sig_84:std_logic_vector(343 downto 0);
signal sig_85:std_logic_vector(347 downto 0);
signal sig_86:std_logic_vector(351 downto 0);
signal sig_87:std_logic_vector(355 downto 0);
signal sig_88:std_logic_vector(359 downto 0);
signal sig_89:std_logic_vector(363 downto 0);
signal sig_90:std_logic_vector(367 downto 0);
signal sig_91:std_logic_vector(371 downto 0);
signal sig_92:std_logic_vector(375 downto 0);
signal sig_93:std_logic_vector(379 downto 0);
signal sig_94:std_logic_vector(383 downto 0);
signal sig_95:std_logic_vector(387 downto 0);
signal sig_96:std_logic_vector(391 downto 0);
signal sig_97:std_logic_vector(395 downto 0);
signal sig_98:std_logic_vector(399 downto 0);
signal sig_99:std_logic_vector(403 downto 0);
signal sig_100:std_logic_vector(407 downto 0);
signal sig_101:std_logic_vector(411 downto 0);
signal sig_102:std_logic_vector(415 downto 0);
signal sig_103:std_logic_vector(419 downto 0);
signal sig_104:std_logic_vector(423 downto 0);
signal sig_105:std_logic_vector(427 downto 0);
signal sig_106:std_logic_vector(431 downto 0);
signal sig_107:std_logic_vector(435 downto 0);
signal sig_108:std_logic_vector(439 downto 0);
signal sig_109:std_logic_vector(443 downto 0);
signal sig_110:std_logic_vector(447 downto 0);
signal sig_111:std_logic_vector(451 downto 0);
signal sig_112:std_logic_vector(455 downto 0);
signal sig_113:std_logic_vector(459 downto 0);
signal sig_114:std_logic_vector(463 downto 0);
signal sig_115:std_logic_vector(467 downto 0);
signal sig_116:std_logic_vector(471 downto 0);
signal sig_117:std_logic_vector(475 downto 0);
signal sig_118:std_logic_vector(479 downto 0);
signal sig_119:std_logic_vector(483 downto 0);
signal sig_120:std_logic_vector(487 downto 0);
signal sig_121:std_logic_vector(491 downto 0);
signal sig_122:std_logic_vector(495 downto 0);
signal sig_123:std_logic_vector(499 downto 0);
signal sig_124:std_logic_vector(503 downto 0);
signal sig_125:std_logic_vector(507 downto 0);
signal sig_126:std_logic_vector(511 downto 0);
signal sig_127:std_logic_vector(515 downto 0);
signal sig_128:std_logic_vector(519 downto 0);
signal sig_129:std_logic_vector(523 downto 0);
signal sig_130:std_logic_vector(527 downto 0);
signal sig_131:std_logic_vector(531 downto 0);
signal sig_132:std_logic_vector(535 downto 0);
signal sig_133:std_logic_vector(539 downto 0);
signal sig_134:std_logic_vector(543 downto 0);
signal sig_135:std_logic_vector(547 downto 0);
signal sig_136:std_logic_vector(551 downto 0);
signal sig_137:std_logic_vector(555 downto 0);
signal sig_138:std_logic_vector(559 downto 0);
signal sig_139:std_logic_vector(563 downto 0);
signal sig_140:std_logic_vector(567 downto 0);
signal sig_141:std_logic_vector(571 downto 0);
signal sig_142:std_logic_vector(575 downto 0);
signal sig_143:std_logic_vector(579 downto 0);
signal sig_144:std_logic_vector(583 downto 0);
signal sig_145:std_logic_vector(587 downto 0);
signal sig_146:std_logic_vector(591 downto 0);
signal sig_147:std_logic_vector(595 downto 0);
signal sig_148:std_logic_vector(599 downto 0);
signal sig_149:std_logic_vector(603 downto 0);
signal sig_150:std_logic_vector(607 downto 0);
signal sig_151:std_logic_vector(611 downto 0);
signal sig_152:std_logic_vector(615 downto 0);
signal sig_153:std_logic_vector(619 downto 0);
signal sig_154:std_logic_vector(623 downto 0);
signal sig_155:std_logic_vector(627 downto 0);
signal sig_156:std_logic_vector(631 downto 0);
signal sig_157:std_logic_vector(635 downto 0);
signal sig_158:std_logic_vector(639 downto 0);
signal sig_159:std_logic_vector(643 downto 0);
signal sig_160:std_logic_vector(647 downto 0);
signal sig_161:std_logic_vector(651 downto 0);
signal sig_162:std_logic_vector(655 downto 0);
signal sig_163:std_logic_vector(659 downto 0);
signal sig_164:std_logic_vector(663 downto 0);
signal sig_165:std_logic_vector(667 downto 0);
signal sig_166:std_logic_vector(671 downto 0);
signal sig_167:std_logic_vector(675 downto 0);
signal sig_168:std_logic_vector(679 downto 0);
signal sig_169:std_logic_vector(683 downto 0);
signal sig_170:std_logic_vector(687 downto 0);
signal sig_171:std_logic_vector(691 downto 0);
signal sig_172:std_logic_vector(695 downto 0);
signal sig_173:std_logic_vector(699 downto 0);
signal sig_174:std_logic_vector(703 downto 0);
signal sig_175:std_logic_vector(707 downto 0);
signal sig_176:std_logic_vector(711 downto 0);
signal sig_177:std_logic_vector(715 downto 0);
signal sig_178:std_logic_vector(719 downto 0);
signal sig_179:std_logic_vector(723 downto 0);
signal sig_180:std_logic_vector(727 downto 0);
signal sig_181:std_logic_vector(731 downto 0);
signal sig_182:std_logic_vector(735 downto 0);
signal sig_183:std_logic_vector(739 downto 0);
signal sig_184:std_logic_vector(743 downto 0);
signal sig_185:std_logic_vector(747 downto 0);
signal sig_186:std_logic_vector(751 downto 0);
signal sig_187:std_logic_vector(755 downto 0);
signal sig_188:std_logic_vector(759 downto 0);
signal sig_189:std_logic_vector(763 downto 0);
signal sig_190:std_logic_vector(767 downto 0);
signal sig_191:std_logic_vector(771 downto 0);
signal sig_192:std_logic_vector(775 downto 0);
signal sig_193:std_logic_vector(779 downto 0);
signal sig_194:std_logic_vector(783 downto 0);
signal sig_195:std_logic_vector(787 downto 0);
signal sig_196:std_logic_vector(791 downto 0);
signal sig_197:std_logic_vector(795 downto 0);
signal sig_198:std_logic_vector(799 downto 0);
signal sig_199:std_logic_vector(803 downto 0);
signal sig_200:std_logic_vector(807 downto 0);
signal sig_201:std_logic_vector(811 downto 0);
signal sig_202:std_logic_vector(815 downto 0);
signal sig_203:std_logic_vector(819 downto 0);
signal sig_204:std_logic_vector(823 downto 0);
signal sig_205:std_logic_vector(827 downto 0);
signal sig_206:std_logic_vector(831 downto 0);
signal sig_207:std_logic_vector(835 downto 0);
signal sig_208:std_logic_vector(839 downto 0);
signal sig_209:std_logic_vector(843 downto 0);
signal sig_210:std_logic_vector(847 downto 0);
signal sig_211:std_logic_vector(851 downto 0);
signal sig_212:std_logic_vector(855 downto 0);
signal sig_213:std_logic_vector(859 downto 0);
signal sig_214:std_logic_vector(863 downto 0);
signal sig_215:std_logic_vector(867 downto 0);
signal sig_216:std_logic_vector(871 downto 0);
signal sig_217:std_logic_vector(875 downto 0);
signal sig_218:std_logic_vector(879 downto 0);
signal sig_219:std_logic_vector(883 downto 0);
signal sig_220:std_logic_vector(887 downto 0);
signal sig_221:std_logic_vector(891 downto 0);
signal sig_222:std_logic_vector(895 downto 0);
signal sig_223:std_logic_vector(899 downto 0);
signal sig_224:std_logic_vector(903 downto 0);
signal sig_225:std_logic_vector(907 downto 0);
signal sig_226:std_logic_vector(911 downto 0);
signal sig_227:std_logic_vector(915 downto 0);
signal sig_228:std_logic_vector(919 downto 0);
signal sig_229:std_logic_vector(923 downto 0);
signal sig_230:std_logic_vector(927 downto 0);
signal sig_231:std_logic_vector(931 downto 0);
signal sig_232:std_logic_vector(935 downto 0);
signal sig_233:std_logic_vector(939 downto 0);
signal sig_234:std_logic_vector(943 downto 0);
signal sig_235:std_logic_vector(947 downto 0);
signal sig_236:std_logic_vector(951 downto 0);
signal sig_237:std_logic_vector(955 downto 0);
signal sig_238:std_logic_vector(959 downto 0);
signal sig_239:std_logic_vector(963 downto 0);
signal sig_240:std_logic_vector(967 downto 0);
signal sig_241:std_logic_vector(971 downto 0);
signal sig_242:std_logic_vector(975 downto 0);
signal sig_243:std_logic_vector(979 downto 0);
signal sig_244:std_logic_vector(983 downto 0);
signal sig_245:std_logic_vector(987 downto 0);
signal sig_246:std_logic_vector(991 downto 0);
signal sig_247:std_logic_vector(995 downto 0);
signal sig_248:std_logic_vector(999 downto 0);
signal sig_249:std_logic_vector(1003 downto 0);
signal sig_250:std_logic_vector(1007 downto 0);
signal sig_251:std_logic_vector(1011 downto 0);
signal sig_252:std_logic_vector(1015 downto 0);
signal sig_253:std_logic_vector(1019 downto 0);
signal sig_254:std_logic_vector(1023 downto 0);
signal B_int:std_logic_vector(1023 downto 0);


begin


   --combinational logics
   dpCMB: process (s_A,sig_0,sig_1,sig_2,sig_3,sig_4,sig_5,sig_6,sig_7,sig_8
,sig_9,sig_10,sig_11,sig_12,sig_13,sig_14,sig_15,sig_16,sig_17,sig_18
,sig_19,sig_20,sig_21,sig_22,sig_23,sig_24,sig_25,sig_26,sig_27,sig_28
,sig_29,sig_30,sig_31,sig_32,sig_33,sig_34,sig_35,sig_36,sig_37,sig_38
,sig_39,sig_40,sig_41,sig_42,sig_43,sig_44,sig_45,sig_46,sig_47,sig_48
,sig_49,sig_50,sig_51,sig_52,sig_53,sig_54,sig_55,sig_56,sig_57,sig_58
,sig_59,sig_60,sig_61,sig_62,sig_63,sig_64,sig_65,sig_66,sig_67,sig_68
,sig_69,sig_70,sig_71,sig_72,sig_73,sig_74,sig_75,sig_76,sig_77,sig_78
,sig_79,sig_80,sig_81,sig_82,sig_83,sig_84,sig_85,sig_86,sig_87,sig_88
,sig_89,sig_90,sig_91,sig_92,sig_93,sig_94,sig_95,sig_96,sig_97,sig_98
,sig_99,sig_100,sig_101,sig_102,sig_103,sig_104,sig_105,sig_106,sig_107,sig_108
,sig_109,sig_110,sig_111,sig_112,sig_113,sig_114,sig_115,sig_116,sig_117,sig_118
,sig_119,sig_120,sig_121,sig_122,sig_123,sig_124,sig_125,sig_126,sig_127,sig_128
,sig_129,sig_130,sig_131,sig_132,sig_133,sig_134,sig_135,sig_136,sig_137,sig_138
,sig_139,sig_140,sig_141,sig_142,sig_143,sig_144,sig_145,sig_146,sig_147,sig_148
,sig_149,sig_150,sig_151,sig_152,sig_153,sig_154,sig_155,sig_156,sig_157,sig_158
,sig_159,sig_160,sig_161,sig_162,sig_163,sig_164,sig_165,sig_166,sig_167,sig_168
,sig_169,sig_170,sig_171,sig_172,sig_173,sig_174,sig_175,sig_176,sig_177,sig_178
,sig_179,sig_180,sig_181,sig_182,sig_183,sig_184,sig_185,sig_186,sig_187,sig_188
,sig_189,sig_190,sig_191,sig_192,sig_193,sig_194,sig_195,sig_196,sig_197,sig_198
,sig_199,sig_200,sig_201,sig_202,sig_203,sig_204,sig_205,sig_206,sig_207,sig_208
,sig_209,sig_210,sig_211,sig_212,sig_213,sig_214,sig_215,sig_216,sig_217,sig_218
,sig_219,sig_220,sig_221,sig_222,sig_223,sig_224,sig_225,sig_226,sig_227,sig_228
,sig_229,sig_230,sig_231,sig_232,sig_233,sig_234,sig_235,sig_236,sig_237,sig_238
,sig_239,sig_240,sig_241,sig_242,sig_243,sig_244,sig_245,sig_246,sig_247,sig_248
,sig_249,sig_250,sig_251,sig_252,sig_253,sig_254,B_int,A)
      begin
         s_A <= (others=>'0');
         sig_0 <= (others=>'0');
         sig_1 <= (others=>'0');
         sig_2 <= (others=>'0');
         sig_3 <= (others=>'0');
         sig_4 <= (others=>'0');
         sig_5 <= (others=>'0');
         sig_6 <= (others=>'0');
         sig_7 <= (others=>'0');
         sig_8 <= (others=>'0');
         sig_9 <= (others=>'0');
         sig_10 <= (others=>'0');
         sig_11 <= (others=>'0');
         sig_12 <= (others=>'0');
         sig_13 <= (others=>'0');
         sig_14 <= (others=>'0');
         sig_15 <= (others=>'0');
         sig_16 <= (others=>'0');
         sig_17 <= (others=>'0');
         sig_18 <= (others=>'0');
         sig_19 <= (others=>'0');
         sig_20 <= (others=>'0');
         sig_21 <= (others=>'0');
         sig_22 <= (others=>'0');
         sig_23 <= (others=>'0');
         sig_24 <= (others=>'0');
         sig_25 <= (others=>'0');
         sig_26 <= (others=>'0');
         sig_27 <= (others=>'0');
         sig_28 <= (others=>'0');
         sig_29 <= (others=>'0');
         sig_30 <= (others=>'0');
         sig_31 <= (others=>'0');
         sig_32 <= (others=>'0');
         sig_33 <= (others=>'0');
         sig_34 <= (others=>'0');
         sig_35 <= (others=>'0');
         sig_36 <= (others=>'0');
         sig_37 <= (others=>'0');
         sig_38 <= (others=>'0');
         sig_39 <= (others=>'0');
         sig_40 <= (others=>'0');
         sig_41 <= (others=>'0');
         sig_42 <= (others=>'0');
         sig_43 <= (others=>'0');
         sig_44 <= (others=>'0');
         sig_45 <= (others=>'0');
         sig_46 <= (others=>'0');
         sig_47 <= (others=>'0');
         sig_48 <= (others=>'0');
         sig_49 <= (others=>'0');
         sig_50 <= (others=>'0');
         sig_51 <= (others=>'0');
         sig_52 <= (others=>'0');
         sig_53 <= (others=>'0');
         sig_54 <= (others=>'0');
         sig_55 <= (others=>'0');
         sig_56 <= (others=>'0');
         sig_57 <= (others=>'0');
         sig_58 <= (others=>'0');
         sig_59 <= (others=>'0');
         sig_60 <= (others=>'0');
         sig_61 <= (others=>'0');
         sig_62 <= (others=>'0');
         sig_63 <= (others=>'0');
         sig_64 <= (others=>'0');
         sig_65 <= (others=>'0');
         sig_66 <= (others=>'0');
         sig_67 <= (others=>'0');
         sig_68 <= (others=>'0');
         sig_69 <= (others=>'0');
         sig_70 <= (others=>'0');
         sig_71 <= (others=>'0');
         sig_72 <= (others=>'0');
         sig_73 <= (others=>'0');
         sig_74 <= (others=>'0');
         sig_75 <= (others=>'0');
         sig_76 <= (others=>'0');
         sig_77 <= (others=>'0');
         sig_78 <= (others=>'0');
         sig_79 <= (others=>'0');
         sig_80 <= (others=>'0');
         sig_81 <= (others=>'0');
         sig_82 <= (others=>'0');
         sig_83 <= (others=>'0');
         sig_84 <= (others=>'0');
         sig_85 <= (others=>'0');
         sig_86 <= (others=>'0');
         sig_87 <= (others=>'0');
         sig_88 <= (others=>'0');
         sig_89 <= (others=>'0');
         sig_90 <= (others=>'0');
         sig_91 <= (others=>'0');
         sig_92 <= (others=>'0');
         sig_93 <= (others=>'0');
         sig_94 <= (others=>'0');
         sig_95 <= (others=>'0');
         sig_96 <= (others=>'0');
         sig_97 <= (others=>'0');
         sig_98 <= (others=>'0');
         sig_99 <= (others=>'0');
         sig_100 <= (others=>'0');
         sig_101 <= (others=>'0');
         sig_102 <= (others=>'0');
         sig_103 <= (others=>'0');
         sig_104 <= (others=>'0');
         sig_105 <= (others=>'0');
         sig_106 <= (others=>'0');
         sig_107 <= (others=>'0');
         sig_108 <= (others=>'0');
         sig_109 <= (others=>'0');
         sig_110 <= (others=>'0');
         sig_111 <= (others=>'0');
         sig_112 <= (others=>'0');
         sig_113 <= (others=>'0');
         sig_114 <= (others=>'0');
         sig_115 <= (others=>'0');
         sig_116 <= (others=>'0');
         sig_117 <= (others=>'0');
         sig_118 <= (others=>'0');
         sig_119 <= (others=>'0');
         sig_120 <= (others=>'0');
         sig_121 <= (others=>'0');
         sig_122 <= (others=>'0');
         sig_123 <= (others=>'0');
         sig_124 <= (others=>'0');
         sig_125 <= (others=>'0');
         sig_126 <= (others=>'0');
         sig_127 <= (others=>'0');
         sig_128 <= (others=>'0');
         sig_129 <= (others=>'0');
         sig_130 <= (others=>'0');
         sig_131 <= (others=>'0');
         sig_132 <= (others=>'0');
         sig_133 <= (others=>'0');
         sig_134 <= (others=>'0');
         sig_135 <= (others=>'0');
         sig_136 <= (others=>'0');
         sig_137 <= (others=>'0');
         sig_138 <= (others=>'0');
         sig_139 <= (others=>'0');
         sig_140 <= (others=>'0');
         sig_141 <= (others=>'0');
         sig_142 <= (others=>'0');
         sig_143 <= (others=>'0');
         sig_144 <= (others=>'0');
         sig_145 <= (others=>'0');
         sig_146 <= (others=>'0');
         sig_147 <= (others=>'0');
         sig_148 <= (others=>'0');
         sig_149 <= (others=>'0');
         sig_150 <= (others=>'0');
         sig_151 <= (others=>'0');
         sig_152 <= (others=>'0');
         sig_153 <= (others=>'0');
         sig_154 <= (others=>'0');
         sig_155 <= (others=>'0');
         sig_156 <= (others=>'0');
         sig_157 <= (others=>'0');
         sig_158 <= (others=>'0');
         sig_159 <= (others=>'0');
         sig_160 <= (others=>'0');
         sig_161 <= (others=>'0');
         sig_162 <= (others=>'0');
         sig_163 <= (others=>'0');
         sig_164 <= (others=>'0');
         sig_165 <= (others=>'0');
         sig_166 <= (others=>'0');
         sig_167 <= (others=>'0');
         sig_168 <= (others=>'0');
         sig_169 <= (others=>'0');
         sig_170 <= (others=>'0');
         sig_171 <= (others=>'0');
         sig_172 <= (others=>'0');
         sig_173 <= (others=>'0');
         sig_174 <= (others=>'0');
         sig_175 <= (others=>'0');
         sig_176 <= (others=>'0');
         sig_177 <= (others=>'0');
         sig_178 <= (others=>'0');
         sig_179 <= (others=>'0');
         sig_180 <= (others=>'0');
         sig_181 <= (others=>'0');
         sig_182 <= (others=>'0');
         sig_183 <= (others=>'0');
         sig_184 <= (others=>'0');
         sig_185 <= (others=>'0');
         sig_186 <= (others=>'0');
         sig_187 <= (others=>'0');
         sig_188 <= (others=>'0');
         sig_189 <= (others=>'0');
         sig_190 <= (others=>'0');
         sig_191 <= (others=>'0');
         sig_192 <= (others=>'0');
         sig_193 <= (others=>'0');
         sig_194 <= (others=>'0');
         sig_195 <= (others=>'0');
         sig_196 <= (others=>'0');
         sig_197 <= (others=>'0');
         sig_198 <= (others=>'0');
         sig_199 <= (others=>'0');
         sig_200 <= (others=>'0');
         sig_201 <= (others=>'0');
         sig_202 <= (others=>'0');
         sig_203 <= (others=>'0');
         sig_204 <= (others=>'0');
         sig_205 <= (others=>'0');
         sig_206 <= (others=>'0');
         sig_207 <= (others=>'0');
         sig_208 <= (others=>'0');
         sig_209 <= (others=>'0');
         sig_210 <= (others=>'0');
         sig_211 <= (others=>'0');
         sig_212 <= (others=>'0');
         sig_213 <= (others=>'0');
         sig_214 <= (others=>'0');
         sig_215 <= (others=>'0');
         sig_216 <= (others=>'0');
         sig_217 <= (others=>'0');
         sig_218 <= (others=>'0');
         sig_219 <= (others=>'0');
         sig_220 <= (others=>'0');
         sig_221 <= (others=>'0');
         sig_222 <= (others=>'0');
         sig_223 <= (others=>'0');
         sig_224 <= (others=>'0');
         sig_225 <= (others=>'0');
         sig_226 <= (others=>'0');
         sig_227 <= (others=>'0');
         sig_228 <= (others=>'0');
         sig_229 <= (others=>'0');
         sig_230 <= (others=>'0');
         sig_231 <= (others=>'0');
         sig_232 <= (others=>'0');
         sig_233 <= (others=>'0');
         sig_234 <= (others=>'0');
         sig_235 <= (others=>'0');
         sig_236 <= (others=>'0');
         sig_237 <= (others=>'0');
         sig_238 <= (others=>'0');
         sig_239 <= (others=>'0');
         sig_240 <= (others=>'0');
         sig_241 <= (others=>'0');
         sig_242 <= (others=>'0');
         sig_243 <= (others=>'0');
         sig_244 <= (others=>'0');
         sig_245 <= (others=>'0');
         sig_246 <= (others=>'0');
         sig_247 <= (others=>'0');
         sig_248 <= (others=>'0');
         sig_249 <= (others=>'0');
         sig_250 <= (others=>'0');
         sig_251 <= (others=>'0');
         sig_252 <= (others=>'0');
         sig_253 <= (others=>'0');
         sig_254 <= (others=>'0');
         B_int <= (others=>'0');
         B <= (others=>'0');

         s_A <= A;
         sig_0 <= s_A(1023 downto 1020) & s_A(1011 downto 1008);
         sig_1 <= sig_0 & s_A(1007 downto 1004);
         sig_2 <= sig_1 & s_A(995 downto 992);
         sig_3 <= sig_2 & s_A(991 downto 988);
         sig_4 <= sig_3 & s_A(979 downto 976);
         sig_5 <= sig_4 & s_A(975 downto 972);
         sig_6 <= sig_5 & s_A(963 downto 960);
         sig_7 <= sig_6 & s_A(959 downto 956);
         sig_8 <= sig_7 & s_A(947 downto 944);
         sig_9 <= sig_8 & s_A(943 downto 940);
         sig_10 <= sig_9 & s_A(931 downto 928);
         sig_11 <= sig_10 & s_A(927 downto 924);
         sig_12 <= sig_11 & s_A(915 downto 912);
         sig_13 <= sig_12 & s_A(911 downto 908);
         sig_14 <= sig_13 & s_A(899 downto 896);
         sig_15 <= sig_14 & s_A(895 downto 892);
         sig_16 <= sig_15 & s_A(883 downto 880);
         sig_17 <= sig_16 & s_A(879 downto 876);
         sig_18 <= sig_17 & s_A(867 downto 864);
         sig_19 <= sig_18 & s_A(863 downto 860);
         sig_20 <= sig_19 & s_A(851 downto 848);
         sig_21 <= sig_20 & s_A(847 downto 844);
         sig_22 <= sig_21 & s_A(835 downto 832);
         sig_23 <= sig_22 & s_A(831 downto 828);
         sig_24 <= sig_23 & s_A(819 downto 816);
         sig_25 <= sig_24 & s_A(815 downto 812);
         sig_26 <= sig_25 & s_A(803 downto 800);
         sig_27 <= sig_26 & s_A(799 downto 796);
         sig_28 <= sig_27 & s_A(787 downto 784);
         sig_29 <= sig_28 & s_A(783 downto 780);
         sig_30 <= sig_29 & s_A(771 downto 768);
         sig_31 <= sig_30 & s_A(767 downto 764);
         sig_32 <= sig_31 & s_A(755 downto 752);
         sig_33 <= sig_32 & s_A(751 downto 748);
         sig_34 <= sig_33 & s_A(739 downto 736);
         sig_35 <= sig_34 & s_A(735 downto 732);
         sig_36 <= sig_35 & s_A(723 downto 720);
         sig_37 <= sig_36 & s_A(719 downto 716);
         sig_38 <= sig_37 & s_A(707 downto 704);
         sig_39 <= sig_38 & s_A(703 downto 700);
         sig_40 <= sig_39 & s_A(691 downto 688);
         sig_41 <= sig_40 & s_A(687 downto 684);
         sig_42 <= sig_41 & s_A(675 downto 672);
         sig_43 <= sig_42 & s_A(671 downto 668);
         sig_44 <= sig_43 & s_A(659 downto 656);
         sig_45 <= sig_44 & s_A(655 downto 652);
         sig_46 <= sig_45 & s_A(643 downto 640);
         sig_47 <= sig_46 & s_A(639 downto 636);
         sig_48 <= sig_47 & s_A(627 downto 624);
         sig_49 <= sig_48 & s_A(623 downto 620);
         sig_50 <= sig_49 & s_A(611 downto 608);
         sig_51 <= sig_50 & s_A(607 downto 604);
         sig_52 <= sig_51 & s_A(595 downto 592);
         sig_53 <= sig_52 & s_A(591 downto 588);
         sig_54 <= sig_53 & s_A(579 downto 576);
         sig_55 <= sig_54 & s_A(575 downto 572);
         sig_56 <= sig_55 & s_A(563 downto 560);
         sig_57 <= sig_56 & s_A(559 downto 556);
         sig_58 <= sig_57 & s_A(547 downto 544);
         sig_59 <= sig_58 & s_A(543 downto 540);
         sig_60 <= sig_59 & s_A(531 downto 528);
         sig_61 <= sig_60 & s_A(527 downto 524);
         sig_62 <= sig_61 & s_A(515 downto 512);
         sig_63 <= sig_62 & s_A(511 downto 508);
         sig_64 <= sig_63 & s_A(499 downto 496);
         sig_65 <= sig_64 & s_A(495 downto 492);
         sig_66 <= sig_65 & s_A(483 downto 480);
         sig_67 <= sig_66 & s_A(479 downto 476);
         sig_68 <= sig_67 & s_A(467 downto 464);
         sig_69 <= sig_68 & s_A(463 downto 460);
         sig_70 <= sig_69 & s_A(451 downto 448);
         sig_71 <= sig_70 & s_A(447 downto 444);
         sig_72 <= sig_71 & s_A(435 downto 432);
         sig_73 <= sig_72 & s_A(431 downto 428);
         sig_74 <= sig_73 & s_A(419 downto 416);
         sig_75 <= sig_74 & s_A(415 downto 412);
         sig_76 <= sig_75 & s_A(403 downto 400);
         sig_77 <= sig_76 & s_A(399 downto 396);
         sig_78 <= sig_77 & s_A(387 downto 384);
         sig_79 <= sig_78 & s_A(383 downto 380);
         sig_80 <= sig_79 & s_A(371 downto 368);
         sig_81 <= sig_80 & s_A(367 downto 364);
         sig_82 <= sig_81 & s_A(355 downto 352);
         sig_83 <= sig_82 & s_A(351 downto 348);
         sig_84 <= sig_83 & s_A(339 downto 336);
         sig_85 <= sig_84 & s_A(335 downto 332);
         sig_86 <= sig_85 & s_A(323 downto 320);
         sig_87 <= sig_86 & s_A(319 downto 316);
         sig_88 <= sig_87 & s_A(307 downto 304);
         sig_89 <= sig_88 & s_A(303 downto 300);
         sig_90 <= sig_89 & s_A(291 downto 288);
         sig_91 <= sig_90 & s_A(287 downto 284);
         sig_92 <= sig_91 & s_A(275 downto 272);
         sig_93 <= sig_92 & s_A(271 downto 268);
         sig_94 <= sig_93 & s_A(259 downto 256);
         sig_95 <= sig_94 & s_A(255 downto 252);
         sig_96 <= sig_95 & s_A(243 downto 240);
         sig_97 <= sig_96 & s_A(239 downto 236);
         sig_98 <= sig_97 & s_A(227 downto 224);
         sig_99 <= sig_98 & s_A(223 downto 220);
         sig_100 <= sig_99 & s_A(211 downto 208);
         sig_101 <= sig_100 & s_A(207 downto 204);
         sig_102 <= sig_101 & s_A(195 downto 192);
         sig_103 <= sig_102 & s_A(191 downto 188);
         sig_104 <= sig_103 & s_A(179 downto 176);
         sig_105 <= sig_104 & s_A(175 downto 172);
         sig_106 <= sig_105 & s_A(163 downto 160);
         sig_107 <= sig_106 & s_A(159 downto 156);
         sig_108 <= sig_107 & s_A(147 downto 144);
         sig_109 <= sig_108 & s_A(143 downto 140);
         sig_110 <= sig_109 & s_A(131 downto 128);
         sig_111 <= sig_110 & s_A(127 downto 124);
         sig_112 <= sig_111 & s_A(115 downto 112);
         sig_113 <= sig_112 & s_A(111 downto 108);
         sig_114 <= sig_113 & s_A(99 downto 96);
         sig_115 <= sig_114 & s_A(95 downto 92);
         sig_116 <= sig_115 & s_A(83 downto 80);
         sig_117 <= sig_116 & s_A(79 downto 76);
         sig_118 <= sig_117 & s_A(67 downto 64);
         sig_119 <= sig_118 & s_A(63 downto 60);
         sig_120 <= sig_119 & s_A(51 downto 48);
         sig_121 <= sig_120 & s_A(47 downto 44);
         sig_122 <= sig_121 & s_A(35 downto 32);
         sig_123 <= sig_122 & s_A(31 downto 28);
         sig_124 <= sig_123 & s_A(19 downto 16);
         sig_125 <= sig_124 & s_A(15 downto 12);
         sig_126 <= sig_125 & s_A(3 downto 0);
         sig_127 <= sig_126 & s_A(1015 downto 1012);
         sig_128 <= sig_127 & s_A(1019 downto 1016);
         sig_129 <= sig_128 & s_A(999 downto 996);
         sig_130 <= sig_129 & s_A(1003 downto 1000);
         sig_131 <= sig_130 & s_A(983 downto 980);
         sig_132 <= sig_131 & s_A(987 downto 984);
         sig_133 <= sig_132 & s_A(967 downto 964);
         sig_134 <= sig_133 & s_A(971 downto 968);
         sig_135 <= sig_134 & s_A(951 downto 948);
         sig_136 <= sig_135 & s_A(955 downto 952);
         sig_137 <= sig_136 & s_A(935 downto 932);
         sig_138 <= sig_137 & s_A(939 downto 936);
         sig_139 <= sig_138 & s_A(919 downto 916);
         sig_140 <= sig_139 & s_A(923 downto 920);
         sig_141 <= sig_140 & s_A(903 downto 900);
         sig_142 <= sig_141 & s_A(907 downto 904);
         sig_143 <= sig_142 & s_A(887 downto 884);
         sig_144 <= sig_143 & s_A(891 downto 888);
         sig_145 <= sig_144 & s_A(871 downto 868);
         sig_146 <= sig_145 & s_A(875 downto 872);
         sig_147 <= sig_146 & s_A(855 downto 852);
         sig_148 <= sig_147 & s_A(859 downto 856);
         sig_149 <= sig_148 & s_A(839 downto 836);
         sig_150 <= sig_149 & s_A(843 downto 840);
         sig_151 <= sig_150 & s_A(823 downto 820);
         sig_152 <= sig_151 & s_A(827 downto 824);
         sig_153 <= sig_152 & s_A(807 downto 804);
         sig_154 <= sig_153 & s_A(811 downto 808);
         sig_155 <= sig_154 & s_A(791 downto 788);
         sig_156 <= sig_155 & s_A(795 downto 792);
         sig_157 <= sig_156 & s_A(775 downto 772);
         sig_158 <= sig_157 & s_A(779 downto 776);
         sig_159 <= sig_158 & s_A(759 downto 756);
         sig_160 <= sig_159 & s_A(763 downto 760);
         sig_161 <= sig_160 & s_A(743 downto 740);
         sig_162 <= sig_161 & s_A(747 downto 744);
         sig_163 <= sig_162 & s_A(727 downto 724);
         sig_164 <= sig_163 & s_A(731 downto 728);
         sig_165 <= sig_164 & s_A(711 downto 708);
         sig_166 <= sig_165 & s_A(715 downto 712);
         sig_167 <= sig_166 & s_A(695 downto 692);
         sig_168 <= sig_167 & s_A(699 downto 696);
         sig_169 <= sig_168 & s_A(679 downto 676);
         sig_170 <= sig_169 & s_A(683 downto 680);
         sig_171 <= sig_170 & s_A(663 downto 660);
         sig_172 <= sig_171 & s_A(667 downto 664);
         sig_173 <= sig_172 & s_A(647 downto 644);
         sig_174 <= sig_173 & s_A(651 downto 648);
         sig_175 <= sig_174 & s_A(631 downto 628);
         sig_176 <= sig_175 & s_A(635 downto 632);
         sig_177 <= sig_176 & s_A(615 downto 612);
         sig_178 <= sig_177 & s_A(619 downto 616);
         sig_179 <= sig_178 & s_A(599 downto 596);
         sig_180 <= sig_179 & s_A(603 downto 600);
         sig_181 <= sig_180 & s_A(583 downto 580);
         sig_182 <= sig_181 & s_A(587 downto 584);
         sig_183 <= sig_182 & s_A(567 downto 564);
         sig_184 <= sig_183 & s_A(571 downto 568);
         sig_185 <= sig_184 & s_A(551 downto 548);
         sig_186 <= sig_185 & s_A(555 downto 552);
         sig_187 <= sig_186 & s_A(535 downto 532);
         sig_188 <= sig_187 & s_A(539 downto 536);
         sig_189 <= sig_188 & s_A(519 downto 516);
         sig_190 <= sig_189 & s_A(523 downto 520);
         sig_191 <= sig_190 & s_A(503 downto 500);
         sig_192 <= sig_191 & s_A(507 downto 504);
         sig_193 <= sig_192 & s_A(487 downto 484);
         sig_194 <= sig_193 & s_A(491 downto 488);
         sig_195 <= sig_194 & s_A(471 downto 468);
         sig_196 <= sig_195 & s_A(475 downto 472);
         sig_197 <= sig_196 & s_A(455 downto 452);
         sig_198 <= sig_197 & s_A(459 downto 456);
         sig_199 <= sig_198 & s_A(439 downto 436);
         sig_200 <= sig_199 & s_A(443 downto 440);
         sig_201 <= sig_200 & s_A(423 downto 420);
         sig_202 <= sig_201 & s_A(427 downto 424);
         sig_203 <= sig_202 & s_A(407 downto 404);
         sig_204 <= sig_203 & s_A(411 downto 408);
         sig_205 <= sig_204 & s_A(391 downto 388);
         sig_206 <= sig_205 & s_A(395 downto 392);
         sig_207 <= sig_206 & s_A(375 downto 372);
         sig_208 <= sig_207 & s_A(379 downto 376);
         sig_209 <= sig_208 & s_A(359 downto 356);
         sig_210 <= sig_209 & s_A(363 downto 360);
         sig_211 <= sig_210 & s_A(343 downto 340);
         sig_212 <= sig_211 & s_A(347 downto 344);
         sig_213 <= sig_212 & s_A(327 downto 324);
         sig_214 <= sig_213 & s_A(331 downto 328);
         sig_215 <= sig_214 & s_A(311 downto 308);
         sig_216 <= sig_215 & s_A(315 downto 312);
         sig_217 <= sig_216 & s_A(295 downto 292);
         sig_218 <= sig_217 & s_A(299 downto 296);
         sig_219 <= sig_218 & s_A(279 downto 276);
         sig_220 <= sig_219 & s_A(283 downto 280);
         sig_221 <= sig_220 & s_A(263 downto 260);
         sig_222 <= sig_221 & s_A(267 downto 264);
         sig_223 <= sig_222 & s_A(247 downto 244);
         sig_224 <= sig_223 & s_A(251 downto 248);
         sig_225 <= sig_224 & s_A(231 downto 228);
         sig_226 <= sig_225 & s_A(235 downto 232);
         sig_227 <= sig_226 & s_A(215 downto 212);
         sig_228 <= sig_227 & s_A(219 downto 216);
         sig_229 <= sig_228 & s_A(199 downto 196);
         sig_230 <= sig_229 & s_A(203 downto 200);
         sig_231 <= sig_230 & s_A(183 downto 180);
         sig_232 <= sig_231 & s_A(187 downto 184);
         sig_233 <= sig_232 & s_A(167 downto 164);
         sig_234 <= sig_233 & s_A(171 downto 168);
         sig_235 <= sig_234 & s_A(151 downto 148);
         sig_236 <= sig_235 & s_A(155 downto 152);
         sig_237 <= sig_236 & s_A(135 downto 132);
         sig_238 <= sig_237 & s_A(139 downto 136);
         sig_239 <= sig_238 & s_A(119 downto 116);
         sig_240 <= sig_239 & s_A(123 downto 120);
         sig_241 <= sig_240 & s_A(103 downto 100);
         sig_242 <= sig_241 & s_A(107 downto 104);
         sig_243 <= sig_242 & s_A(87 downto 84);
         sig_244 <= sig_243 & s_A(91 downto 88);
         sig_245 <= sig_244 & s_A(71 downto 68);
         sig_246 <= sig_245 & s_A(75 downto 72);
         sig_247 <= sig_246 & s_A(55 downto 52);
         sig_248 <= sig_247 & s_A(59 downto 56);
         sig_249 <= sig_248 & s_A(39 downto 36);
         sig_250 <= sig_249 & s_A(43 downto 40);
         sig_251 <= sig_250 & s_A(23 downto 20);
         sig_252 <= sig_251 & s_A(27 downto 24);
         sig_253 <= sig_252 & s_A(7 downto 4);
         sig_254 <= sig_253 & s_A(11 downto 8);
         B <= B_int;
         B_int <= sig_254;
      end process dpCMB;
end RTL;
